<html>
<head>
<title>Ogre::InstanceManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1InstanceManager.html">InstanceManager</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::InstanceManager Class Reference<div class="ingroups"><a class="el" href="group__Scene.html">Scene</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::InstanceManager" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>This is the main starting point for the new instancing system.  
 <a href="classOgre_1_1InstanceManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreInstanceManager_8h_source.html">OgreInstanceManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::InstanceManager:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1InstanceManager__inherit__graph.gif" border="0" usemap="#Ogre_1_1InstanceManager_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1InstanceManager_inherit__map" id="Ogre_1_1InstanceManager_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="37,5,131,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1InstanceManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1InstanceManager_1_1BatchSettings.html">BatchSettings</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a> { <br/>
&#160;&#160;<a class="el" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622adfd14a6d905e8f639010dceb63fd6a99">ShaderBased</a>, 
<a class="el" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622aa936e137d1695cec1b763a270dc73a3e">TextureVTF</a>, 
<a class="el" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622a20f1ebda9178d5f5f4ebe613f3432eac">HWInstancingBasic</a>, 
<a class="el" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622ac1ad45db6c7bc954c0374c37c8ed1b0d">HWInstancingVTF</a>, 
<br/>
&#160;&#160;<a class="el" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622a3efbc531e529142ddfd5c7272a373ece">InstancingTechniquesCount</a>
<br/>
 }</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">BatchSettingId</a> { <a class="el" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a4fa34122dba5df1604cd9cd44ee1c519">CAST_SHADOWS</a> =  0, 
<a class="el" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a5aa5845eaa01e5c54fc92fc74b2f4176">SHOW_BOUNDINGBOX</a>, 
<a class="el" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a93252cb20077bbc127c02d96f5d696f0">NUM_SETTINGS</a>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Values to be used in <a class="el" href="group__Scene.html#ga33efe914b96f2b2f3367cca266a0a88b" title="Applies a setting for all batches using the same material_ existing ones and those that will be creat...">setSetting()</a> &amp; <a class="el" href="group__Scene.html#ga2c32100efe26093807424d2032f66464">BatchSettings::setting</a>.  <a href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classOgre_1_1ConstMapIterator.html">ConstMapIterator</a><br class="typebreak"/>
&lt; <a class="el" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">InstanceBatchMap</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga449864e9fe068c83c3955dfcc112a2d1">InstanceBatchMapIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classOgre_1_1ConstVectorIterator.html">ConstVectorIterator</a><br class="typebreak"/>
&lt; <a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga81a850f3da3dc22baa6d8fbd68a1723f">InstanceBatchIterator</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gab31a5819d546d97995e9c5fc0f6dbe76">InstanceManager</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;customName, <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sceneManager, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;meshName, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;groupName, <a class="el" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a> instancingTechnique, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> instancingFlags, size_t instancesPerBatch, unsigned short subMeshIdx, bool useBoneMatrixLookup=false)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga389862a9932c13829fa881e82f3593c3">~InstanceManager</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gaa0ac29a317cd26fd5b83b18598b081b4">getName</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga20c5c86323fe3d15f2531e88d8299b17">setInstancesPerBatch</a> (size_t instancesPerBatch)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Raises an exception if trying to change it after creating the first <a class="el" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>.  <a href="group__Scene.html#ga20c5c86323fe3d15f2531e88d8299b17"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga784eee0c3b16d9a661c39ad24459b0cb">setMaxLookupTableInstances</a> (size_t maxLookupTableInstances)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the size of the lookup table for techniques supporting bone lookup table.  <a href="group__Scene.html#ga784eee0c3b16d9a661c39ad24459b0cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga2623303420a636cfc8b06784da9077de">getMaxOrBestNumInstancesPerBatch</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> materialName, size_t suggestedSize, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> flags)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the maximum (or the best amount, depending on flags) of instances per batch given the suggested size for the technique this manager was created for.  <a href="group__Scene.html#ga2623303420a636cfc8b06784da9077de"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga5767c95dac43bbc3c80966c362e32b73">createInstancedEntity</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga78d1331b24a26e89d49b50c0293bdab2">cleanupEmptyBatches</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This function can be useful to improve CPU speed after having too many instances created, which where now removed, thus freeing many batches with zero used Instanced Entities However the batches aren't automatically removed from memory until the <a class="el" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> is destroyed, or this function is called.  <a href="group__Scene.html#ga78d1331b24a26e89d49b50c0293bdab2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gad95874d5f995a6b7b66707cb260a0a19">defragmentBatches</a> (bool optimizeCulling)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">After creating many entities (which turns in many batches) and then removing entities that are in the middle of these batches, there might be many batches with many free entities.  <a href="group__Scene.html#gad95874d5f995a6b7b66707cb260a0a19"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga33efe914b96f2b2f3367cca266a0a88b">setSetting</a> (<a class="el" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">BatchSettingId</a> id, bool value, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName=<a class="el" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da">StringUtil::BLANK</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies a setting for all batches using the same material_ existing ones and those that will be created in the future.  <a href="group__Scene.html#ga33efe914b96f2b2f3367cca266a0a88b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gaf6062a475ef8cf4e1366a9d7f5301417">getSetting</a> (<a class="el" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">BatchSettingId</a> id, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If settings for the given material didn't exist, default value is returned.  <a href="group__Scene.html#gaf6062a475ef8cf4e1366a9d7f5301417"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga5fe7226ee5363b1b369d684d15af519f">hasSettings</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if settings were already created for the given material name.  <a href="group__Scene.html#ga5fe7226ee5363b1b369d684d15af519f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gaadfa0ab4a3974108898a518a1f789961">setBatchesAsStaticAndUpdate</a> (bool bStatic)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga395a8ce5c926625f1902d7f645d041fc">_addDirtyBatch</a> (<a class="el" href="classOgre_1_1InstanceBatch.html">InstanceBatch</a> *dirtyBatch)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called by an <a class="el" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> when it requests their bounds to be updated for proper culling.  <a href="group__Scene.html#ga395a8ce5c926625f1902d7f645d041fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga5a53a7786df59317f4b208b55bd3ec41">_updateDirtyBatches</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called by <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> when we told it we have at least one dirty batch.  <a href="group__Scene.html#ga5a53a7786df59317f4b208b55bd3ec41"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga449864e9fe068c83c3955dfcc112a2d1">InstanceBatchMapIterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga865be521d280fc4daed5bbf0484ab65f">getInstanceBatchMapIterator</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get non-updateable iterator over instance batches per material.  <a href="group__Scene.html#ga865be521d280fc4daed5bbf0484ab65f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga81a850f3da3dc22baa6d8fbd68a1723f">InstanceBatchIterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga5f829261ff3c96310308825bfc5ebe0b">getInstanceBatchIterator</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get non-updateable iterator over instance batches for given material.  <a href="group__Scene.html#ga5f829261ff3c96310308825bfc5ebe0b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1InstanceBatch.html">InstanceBatch</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">InstanceBatchMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="structOgre_1_1InstanceManager_1_1BatchSettings.html">BatchSettings</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gafb62bc67a8ccd5ce513811585cecffd9">BatchSettingsMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1InstanceBatch.html">InstanceBatch</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gacba919ff8e5a0cd355c232f716b613b3">getFreeBatch</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds a batch with at least one free instanced entity we can use.  <a href="group__Scene.html#gacba919ff8e5a0cd355c232f716b613b3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1InstanceBatch.html">InstanceBatch</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gada93fa738779aa7378966715a11e180c">buildNewBatch</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName, bool firstTime)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when batches are fully exhausted (can't return more instances) so a new batch is created.  <a href="group__Scene.html#gada93fa738779aa7378966715a11e180c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga6820aa9b430772b82c3d3622a3ba9856">defragmentBatches</a> (bool optimizeCull, <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> * &gt;::type &amp;entities, <a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &amp;fragmentedBatches)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga1eefc99f2c61f4ef8bcbd5b2d0b08a3e">applySettingToBatches</a> (<a class="el" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">BatchSettingId</a> id, bool value, const <a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &amp;container)</td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga01ab189e423504ec998421dff23f9644">mName</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1MeshPtr.html">MeshPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga2da3cbab89cc6405d656acc508c3f7c8">mMeshReference</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">InstanceBatchMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga9d5879cee81bbc67cdfaf64524bd2169">mInstanceBatches</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga7d4ce97e2f3705998d7722f1c92a766e">mIdCount</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga40e25e0d974bc9cb8fdafef707618d57">mDirtyBatches</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RenderOperation.html">RenderOperation</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga05e37e984cb6aad0278e5201080c6584">mSharedRenderOperation</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga3b584885553efad689ce7f0b006bb6fe">mInstancesPerBatch</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gad52ab17fc279b813acca218429a8b9d5">mInstancingTechnique</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga1d827707f203bd601ecd178717cd9f95">mInstancingFlags</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#gac2afda10e925bbfe4edd50cf7352b66e">mSubMeshIdx</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#gafb62bc67a8ccd5ce513811585cecffd9">BatchSettingsMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga86b59263bf4bac17d33c4365c65c9e37">mBatchSettings</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga31cedf671001b7363491c9facbf95745">mSceneManager</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Scene.html#ga13f71a588460dab9f41c300311af87a6">mMaxLookupTableInstances</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is the main starting point for the new instancing system. </p>
<p>Each <a class="el" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> can control one technique and one mesh, but it can manage multiple materials at the same time. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1SceneManager.html#a5192bd4a4b82ac04c8ea59d4549d5419" title="Creates an InstanceManager interface to create &amp; manipulate instanced entities You need to call this ...">SceneManager::createInstanceManager</a>, which creates this <a class="el" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a>. Each one must have a unique name. It's wasteless to create two InstanceManagers with the same mesh reference, instancing technique and instances per batch count. This class takes care of managing batches automatically, so that more are created when needed, and reuse existing ones as much as posible; thus the user doesn't have to worry of managing all those low level issues. </dd>
<dd>
<a class="el" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> &amp; </dd>
<dd>
InstanceEntity for more information.</dd></dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Design discussion webpage: <a href="http://www.ogre3d.org/forums/viewtopic.php?f=4&t=59902">http://www.ogre3d.org/forums/viewtopic.php?f=4&amp;t=59902</a> </dd></dl>
<dl class="author"><dt><b>Author:</b></dt><dd>Matias N. Goldberg ("dark_sylinc") </dd></dl>
<dl class="version"><dt><b>Version:</b></dt><dd>1.0 </dd></dl>

<p>Definition at line <a class="el" href="OgreInstanceManager_8h_source.html#l00062">62</a> of file <a class="el" href="OgreInstanceManager_8h_source.html">OgreInstanceManager.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::InstanceManager::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::InstanceManager::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::InstanceManager::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::InstanceManager::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::InstanceManager::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::InstanceManager::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::InstanceManager::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::InstanceManager::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::InstanceManager::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::InstanceManager::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreInstanceManager_8h_source.html">OgreInstanceManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:58
</p>
</body>
</html>
